/*
    assemble.h
    assembleļͷ 
    2009.4.12
*/

extern const struct iformat* const instructions[] ;

/*
    ,ָṹ 
    parser.c -> assemble.c
    -0000-0000-0000-0000-0000-0000-0000-0000-
    [31],[30],[29],[28], ... ,[3],[2],[1],[0]
    ڡĳ͡ʱ
    ĳ & ~ == 0                                      
*/

/*
 * λԷ: 
 *
 * λ 0-7: 
 *  0:  8 λ (BYTE)
 *  1: 16 λ (WORD)
 *  2: 32 λ (DWORD)
 *  3: 64 λ (QWORD)
 *  4: SHORT
 *  5: NEAR
 *  6: FAR
 *
 * λ 12-15:  
 * 12: REGISTER
 * 13: IMMEDIATE
 * 14: MEMORY (REGMEM)
 * 15: REGMEM (ЧEA)
 *
 * λ 16-19, 28: 
 *  REG_CDT:
 * 16: REG_CREG (CRx)
 * 17: REG_DREG (DRx)
 * 18: REG_TREG (TRx)

 *  REG_GPR:
 * 16: REG_ACCUM  (AL, AX, EAX, RAX)
 * 17: REG_COUNT  (CL, CX, ECX, RCX)
 * 18: REG_DATA   (DL, DX, EDX, RDX)
 * 19: REG_HIGH   (AH, CH, DH, BH)
 * 28: REG_NOTACC ( REG_ACCUM)
 *
 *  REG_SREG:
 * 16: REG_CS
 * 17: REG_DESS (DS, ES, SS)
 * 18: REG_FSGS
 * 19: REG_SEG67
 *
 *  IMMEDIATE:
 * 16: UNITY (1)
 * 17: BYTENESS16 
 * 18: BYTENESS32 
 * 19: BYTENESS64 
 *
 * λ 20-22: Ĵ 
 * 20: REG_CDT (CRx, DRx, TRx)
 * 21: RM_GPR (REG_GPR) (ͼĴ)
 * 22: REG_SREG
 */

/* 0~6:  */ 
#define BITS8		0x00000001U   /* 0: 8λ(BYTE) */ 
#define BITS16		0x00000002U   /* 1: 16λ(WORD) */ 
#define BITS32		0x00000004U   /* 2: 32λ(DWORD) */  
#define BITS64		0x00000008U   /* 3: 64λ(QWORD) x64 */
#define SHORT		0x00000010U   /* 4: 8λƫ -128~127 */
#define NEAR		0x00000020U   /* 5: 16λƫ */
#define FAR         0x00000040U   /* 6: 32λƫ [CS:IP] */

/* 12~15:  */
#define REGISTER	0x00001000U   /* 12: Ĵ */
#define IMMEDIATE	0x00002000U   /* 13:  */
#define MEMORY		0x0000c000U   /* 14,15: ڴָ(REGMEM) */ 
#define REGMEM		0x00008000U   /* 15: EA(r/m) */

/*  */
#define REG_EA		0x00009000U   /* ""Ĵ,EA */

/*  REG_CDT */
#define REG_CDT		0x00101004U   /* CRn, DRn, TRn */
#define REG_CREG	0x00111004U   /* CRn */
#define REG_DREG	0x00121004U   /* DRn */
#define REG_TREG	0x00141004U   /* TRn */

/*  REG_GPR */
#define RM_GPR		0x00208000U   /* Ͳ */
#define REG_GPR		0x00209000U   /* ͼĴ */
#define REG8		0x00209001U   /* 8λGPR(ͨüĴ) */
#define REG16		0x00209002U   /* 16λGPR(ͨüĴ) */
#define REG32		0x00209004U   /* 32λGPR(ͨüĴ) */
#define REG64		0x00209008U   /* 64λGPR(ͨüĴ) */

/*  REG_SREG */
#define REG_SREG	0x00401002U   /* μĴ */
#define REG_CS		0x00411002U   /* CS */
#define REG_DESS	0x00421002U   /* DS, ES, SS */
#define REG_FSGS	0x00441002U   /* FS, GS */
#define REG_SEG67	0x00481002U   /* δʹõĶμĴ */

/*  IMMEDIATE */
#define UNITY		0x00012000U   /* лָ */
#define SBYTE16		0x00022000U   /* 16λָ */
#define SBYTE32		0x00042000U   /* 32λָ */
#define SBYTE64		0x00082000U   /* 64λָ */

/* EIP,RIP */ 
#define REG_RIP		0x00801008U   /* RIPѰַ */
#define REG_EIP		0x00801004U   /* EIPѰַ */

/* ضͨüĴ(GPR) */
#define REG_ACCUM	0x00219000U   /* ۼӼĴ: AL, AX, EAX, RAX */
#define REG_AL		0x00219001U
#define REG_AX		0x00219002U
#define REG_EAX		0x00219004U
#define REG_RAX		0x00219008U

#define REG_NOTACC	0x10000000U   /* ۼӼĴ */
#define REG_COUNT	0x10229000U   /* : CL, CX, ECX, RCX */
#define REG_CL		0x10229001U
#define REG_CX		0x10229002U
#define REG_ECX		0x10229004U
#define REG_RCX		0x10229008U
#define REG_DL		0x10249001U   /* : DL, DX, EDX, RDX */
#define REG_DX		0x10249002U
#define REG_EDX		0x10249004U
#define REG_RDX		0x10249008U
#define REG_HIGH	0x10289001U   /* λĴ: AH, CH, DH, BH */
#define REG8NA		0x10209001U   /*  8λۼͨüĴ */
#define REG16NA		0x10209002U   /* 16λۼͨüĴ */
#define REG32NA		0x10209004U   /* 32λۼͨüĴ */
#define REG64NA		0x10209008U   /* 64λۼͨüĴ */
