/*
    global.h
    ȫļͷ 
    2009.3.27
*/

# include <ctype.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <stdint.h>

/*  ȫĺ  */
void error(char *s) ;
FILE* read_file(char *file_name) ;
void close_file(FILE *fbuf) ;
FILE* write_file() ;
char* getline(FILE* fbuf) ;

/*  ־  */
# define TRUE !0
# define FALSE 0
# define SET  !0
# define CLEAR 0
# define BYTE 1
# define WORD 2*BYTE
# define DWORD 4*BYTE

/*  CPU־  */
#define IF_8086   0x00000000UL  /* 8086 ָ */
#define IF_286    0x02000000UL  /* 286+ ָ */
#define IF_386    0x03000000UL  /* 386+ ָ */
#define IF_486    0x04000000UL  /* 486+ ָ */
#define IF_586    0x05000000UL  /* 586+ ָ */

/*  enum  */
enum token_type{
    TOKEN_INVALID = -1,
    TOKEN_ID = 256,   /* ʶ */
    TOKEN_EXP,        /* ʽ */ 
    TOKEN_NUM,        /* ʮ */
    TOKEN_HEX,        /* ʮ */
    TOKEN_STR,        /* ַ */
    TOKEN_LAB,        /*  */
    TOKEN_ERR,        /*  */
    TOKEN_DEC,        /*  */ 
    TOKEN_INSN,       /* ָ */
    TOKEN_REG,        /* Ĵ */
    TOKEN_IMME,       /*  */
    TOKEN_MEMORY,     /* ڴָ */
    TOKEN_SPECIAL,    /* SHORT NEAR FARȵ */
    TOKEN_PREFIX,     /* timesǰ׺ */
};

enum reg{
    R_zero = 0,
    R_AH = 1,
    R_CH,
    R_DH,
    R_BH,
    R_AL,
    R_CL,
    R_DL,
    R_BL,
    R_8,  /* Ϊ8λĴ */
    R_AX,
    R_CX,
    R_DX,
    R_BX,
    R_BP,
    R_CS,
    R_DS,
    R_ES,
    R_SS,
    R_16,  /* Ϊ16λĴ */ 
    R_none = -1
} ;

enum spec {
    D_CPU = 1,
    D_BASE,
    P_TIMES,
    S_BITS8,
    S_BITS16,
    S_BITS32,
    S_SHORT,
    S_NEAR,
    S_FAR,
    S_BYTE,
    S_WORD,
    S_DWORD
} ;

/*  ȫֱ  */
int pass1, pass2 ;
int base_adr ;  /*  ַ  */
int this_adr ;  /*  ǰַ  */
int next_adr ;  /*  һַ  */
int cpu_flag ;  /*  CPU־  */
int mod_flag ;  /*  ModR/M־  */
int sib_flag ;  /*  SIB־  */
int dis_flag ;  /*  λƱ־ (Displacement) */
int imm_flag ;  /*  ־  */

# define MAXLINE 128
FILE* fo ;   /*  ļָ */
char ibuf[MAXLINE] ;     /*  ı  */
char key[MAXLINE]  ;     /*    */
char* begin ;
char* forward ; /*  ޵˫ָ  */

/*  ṹ  */
struct box {
    char* str ;
    int token  ;
    uint32_t value ;
} ; /*  Ԫֽ  */
struct box t ; /*  token  */

/*  ָʽ  */
#define MAXOP 5
struct iformat {
    int opcode ;		     // Ƿ
    int operands ;	         //  
    uint32_t opt[MAXOP] ;    // ͱ 
    const uint8_t code ;     //   
    const uint8_t attr ;     // ָ
    uint32_t flags ;	     // һЩ 
} ;

struct instruction {
    int opcode ;		     // Ƿ
    int operands ;	         //  
    uint32_t opv[MAXOP] ;    //  
    uint32_t opt[MAXOP] ;    // ͱ 
    uint32_t flags ;	     // һЩ 
} ;




