/*
    lexer.c
    Lexical analyzer ʷ 
    2009.3.27
*/
# include "header/global.h" 
# include "header/lexer.h" 

struct box* lexan()
{
    char ch ;
    
    while (ch = getch()) {
        switch(state){
        case 0:
            /*  case 0,1: հ׷ָ  */
            if (isspace(ch) || getcp(ch,":,->")) state =1 ;
            else state = fail() ;
            break ;
        case 1:
            if ( isspace(ch) ) state =1 ;
            else { retch() ; recover() ; }
            break ;
        case 2:
            /*  case 2,3,4,5: Cע  */
            if (ch == '/') state = 3 ;
            else state = fail() ;
            break ;
        case 3:
            if (ch == '*') state = 4 ;
            else return get(TOKEN_ERR) ;   /*  ޷ʶĴ  */
            break ;
        case 4:
            if (ch == '*') state = 5 ;
            else state = 4 ;
            break ;
        case 5 :
            if (ch == '/') recover() ;
            else state = 4 ;            
            break ;
        case 6:
            /*  case 6,7: ֺע  */
            if (ch == ';') state = 7 ;
            else state = fail() ;
            break ;
        case 7:
            if (ch == '\n') recover() ;
            else state = 7 ;
            break ;
        case 8:
            /*  case 8,9: ʶ  */
            if ( isalpha(ch) ) state = 9 ;
            else state = fail() ;
            break ;
        case 9:
            if ( isalnum(ch) ) state = 9 ;
            else if (ch == ':') {
                retch() ;
                return get(TOKEN_LAB) ;
            }
            else {
                retch() ;
                return get(TOKEN_ID) ;
            }
            break ;
        case 10:
            /*  case 10,11: ־  */
            if (ch == '.'){
                begin++ ;  /* ȥ.*/
                state = 11 ;
            }
            else state = fail() ;
            break ;
        case 11:
            if ( isalpha(ch) ) state = 11 ;
            else {
                retch() ;
                return get(TOKEN_ID) ;
            }
            break ;
        case 12:
            /*  case 12,13,14: ʽ  */
            if (isdigit(ch)) state = 13 ;
            else if ( getcp(ch,"($") ) state = 14 ;  /*  ʽ  */
            else state = fail() ;
            break ;
        case 13:
            if (getcp(ch,"0x123456789abcdef")) state = 13 ;
            else if ( getcp(ch,"()+-*/$") ) state = 14 ;  /*  ʽ  */
            else if (ch == 'h') return get(TOKEN_HEX) ;
            else {
                retch() ;
                return get(TOKEN_NUM) ;
            }
            break ;
        case 14:
            if (isdigit(ch) || getcp(ch,"()+-*/$") ) state = 14 ;
            else {
                retch() ;
                return get(TOKEN_EXP) ;
            }
            break ;
        case 15:
            /*  case:15,16 ַ  */
            if (ch == '"') {
                begin++ ;  /* ȥ" */ 
                state = 16 ;
            }
            else return get(TOKEN_ERR) ;   /*  ޷ʶĴ  */
            break ;
        case 16:
            if (ch == '"') {
                *(forward-1) = '\0' ;
                return get(TOKEN_STR) ;
            }
            else if (ch == '\n') return get(TOKEN_ERR) ;   /*  ޷ʶĴ  */
            else state = 16 ;  
            break;       
        default:
            break ;
        }   
    }
    return 0 ;
}

/*  һܵ״̬  */
int fail()
{    
    switch (start){
        case 0:  start = 2 ; break ;
        case 2:  start = 6 ; break ;
        case 6:  start = 8 ; break ;
        case 8:  start = 10 ; break ;
        case 10:  start = 12 ; break ;
        case 12:  start = 15 ; break ;
        default: break ;
    }
    forward = begin ;
    return start ;
}

/*  ָָ뼰״̬  */
int recover()
{
    state = start = 0 ;
    begin = forward ;
}

/*  ȡTOKEN  */
struct box* get(int token)
{
    int value = 0 ;
    char s[MAXLINE] = "" ;
    char* str ;
    
    strncpy(s, begin, forward - begin) ;  /*  ƴ  */
    str = (token != TOKEN_ID && token != TOKEN_LAB)
           ? strcpy(key, s)
           : getlower( strcpy(key, s) ) ;  /* Сдַ */
           
    switch (token){
        case TOKEN_EXP:
            token = TOKEN_EXP ;
            value = expr(str) ;
            break ; 
        case TOKEN_HEX: case TOKEN_NUM:
            value = getnum(str) ;
            token = TOKEN_IMME ;
            break ;
        case TOKEN_ID: 
            token = lookup(str, 't') ;
            if (!token) token = TOKEN_ID ;
            else value = lookup(str, 'v') ;
            break ;
        case TOKEN_LAB:
            if (lookup(str, 't') != TOKEN_LAB){
                token = TOKEN_LAB ;
                insert(str, token, this_adr) ;
            }
            else value = lookup(key, 'v') ;
            break ;
        default:
            break ;
    }
    t.str = str ;
    t.token = token ;
    t.value = value ;
    recover() ;
    return &t ;
}
