/*
    parser.c
    Parse analyzer ﷨ 
    2009.4.20 
*/

# include "header/global.h" 
# include "header/parser.h"

int parse(char* string)
{   
    struct box* info ;
    struct instruction insn ;
    int opcode = -1 ;
    int operands = 0 ; /*    */
    int modifier = 0 ; /*  η  */
    int state = 0 ;
    int repeat = 1 ;  /*  αָ:ظ  */
    int op_size = BYTE ;  /*    */

    mod_flag = CLEAR ;
    sib_flag = CLEAR ;
    dis_flag = CLEAR ;
    imm_flag = CLEAR ;
    err_flag = CLEAR ;
    begin = forward = string ;  /*  ָ򻺳  */
    if (pass2) printf("%02X", this_adr) ;
    while (info = lexan()) {
        switch (state) {
        case 0:
            switch (info->token){
            case TOKEN_DEC: /*    */
                switch (info->value){
                case D_BASE:
                    state = 5 ;
                    break ;
                case D_CPU:
                    state = 6 ;
                    break ;
                default: break ;
                }
                break ;
            case TOKEN_SPECIAL:  /*  αָ  */
                switch (info->value){
                case S_BITS8:
                    op_size = BYTE ;
                    break ;
                case S_BITS16:
                    op_size = WORD ;                
                    break ;
                case S_BITS32:
                    op_size = DWORD ;
                    break ;
                default: break ;
                }
                state = 3 ;
                break ;
            case TOKEN_PREFIX:
                if (info->value == P_TIMES)  state =4 ;
                break ;
            case TOKEN_INSN: /*  ָ  */
                opcode = info->value ; /* Ƿ */
                next_adr += op_size ;
                state = 1 ;
                break ;
            case TOKEN_ERR:
                err_flag = SET ;
            default: break ;
            }
            break ;
        case 1:  /*  ĿĲ  */
            if (info->token == TOKEN_SPECIAL){ /* η */ 
                switch (info->value) {
                case S_SHORT:
                    op_size = BYTE ;
                    modifier = SHORT ; 
                    break ;
                case S_NEAR:
                    op_size = WORD ; 
                    modifier = NEAR ; 
                    break ;
                case S_FAR:
                    op_size = DWORD ; 
                    modifier = FAR ; 
                    break ;
                default: break ;
                }
                info = lexan() ;
            }
            else op_size = BYTE ;
            switch (info->token){
            case TOKEN_REG:  /* Ĵ */
                if (info->value <= R_8) 
                    op_size = BYTE ;
                else if (info->value <= R_16)
                    op_size = WORD ;
                else op_size = DWORD ;
                
                state = 2 ;
                break ;
            case TOKEN_ID: case TOKEN_LAB: /* ڴ浥Ԫ */ 
                op_size = WORD ;
                next_adr += op_size ;
                state = 2 ;
                break ;
            case TOKEN_EXP:
                next_adr += op_size ;
                if (!modifier) modifier = SHORT ;
                break ;
            case TOKEN_IMME:  /* I/O˿ */ 
                next_adr += op_size ;
                break ;
            default: 
                err_flag = SET ; 
                break ;
            } 
            insn.opv[operands] = info->value ;  /*  */
            insn.opt[operands] = modifier ?
                                 modifier | expand_token(info) :
                                 expand_token(info) ; /*  */
            operands++ ;
            break ;
        case 2:  /*  Դ  */
            switch (info->token){
            case TOKEN_REG:  /* Ĵ modr/m */
                op_size = BYTE ;
                next_adr += op_size ;
                insn.opv[operands] = info->value ;  /*  */
                break ;
            case TOKEN_ID: case TOKEN_LAB: /* ڴ浥Ԫ */ 
                next_adr += op_size ;
                info->token = TOKEN_IMME ; /* ͬ */ 
                info->value += base_adr ;
                break ;
            case TOKEN_IMME: /*  */
                next_adr += op_size ;
                break ;
            default: 
                err_flag = SET ; 
                break ;
            }
            insn.opv[operands] = info->value ;  /*  */
            insn.opt[operands] = expand_token(info) ; /*  */
            operands++ ;
            break ;
        case 3:  /*  αָ  */
            switch (info->token){
                case TOKEN_STR:
                    next_adr += strlen(info->str) * op_size * repeat ;
                    /* ַ */
                    if (pass2)
                        while (repeat--)
                            fputs(info->str, fo) ;
                    break ;
                case TOKEN_IMME:
                    next_adr += op_size * repeat ;
                    /*  */
                    if (pass2)
                        while (repeat--)
                            output(info->value, op_size) ;
                    break ;
                default: 
                    err_flag = SET ; 
                    break ;
            }
            break ;
        case 4: /*  αָrepeat  */
            switch (info->token){
                case TOKEN_IMME:case TOKEN_EXP:
                    repeat = info->value ;
                    state = 0 ;
                    break ;
                default:
                    err_flag = SET ; 
                    break ;
            }
            break ; 
        case 5:  /*  ַ  */
            if (info->token == TOKEN_IMME) base_adr = info->value ;
            else err_flag = SET ;
            break ;
        case 6:  /*  CPU  */ 
            if (info->token == TOKEN_IMME)
                switch (info->value) {
                case 286:
                    cpu_flag = IF_286 ;
                    break ;
                case 386:
                    cpu_flag = IF_386 ;
                    break ;
                case 486:
                    cpu_flag = IF_486 ;
                    break ;
                case 586:
                    cpu_flag = IF_586 ;
                    break ;
                default:
                    cpu_flag = IF_8086 ;
                    break ;
                }
            else err_flag = SET ;
            break ;
        default:
            err_flag = SET ; 
            break ;   
        }    
    }
    insn.operands = operands ;
    insn.opcode = opcode ;
    insn.flags |= cpu_flag ;   /*  ־  */
    this_adr = next_adr ;
    uint8_t code ;
    uint8_t mod ;
    int imm ;
    int dis ;
    if (pass2){
        if (insn.opcode != -1){
            printf("\topcode:%02X", code = assemble( &insn )) ;
            //fprintf(output, "%c", code) ;
            output(code, BYTE) ;
        }
        if (mod_flag == SET){
            printf("\tModR/M:%02X", mod = modrm(&insn, code)) ;
            output(mod, BYTE) ;
        }
        if (sib_flag == CLEAR && dis_flag == SET){
            printf("\tDisplacement:%0004X", dis = insn.opv[operands-1] - next_adr) ;
            output(dis, op_size) ;
        }
        if (imm_flag == SET){
            printf("\tImmediate:%0004X", imm = insn.opv[operands-1]) ;
            output(imm, op_size) ;
        }
    }
    return err_flag ;
}


